<id>
Post draft feature
</id>

<version>
0.81 SP 1.3.1
</version>

<mod info>
This mods lets Moderators check each posting before it becomes published to your forum's users. This is efficent against spamming and flaming. You only have to enable this feature in the board options.

Only use this mod if you have not the Global Moderators Mod or the Add More Membergroups Mod installed!!!
</mod info>

<author>
Daniel Alm
</author>

<homepage>

</homepage>

<edit file>
english.lng
</edit file>

<search for>
$txt{'796'} = "Your Instant Messages:";
</search for>

<add after>
### DRAFT + PUBLISH MOD START ###
$publishtxt{'01'}="Enable publishing control for this board";
$publishtxt{'02'}="Disable publishing control for this board";
$publishtxt{'05'}="Disable direct publishing of replies?";
$publishtxt{'10'}="Not published";
$publishtxt{'20'}="This thread has not been published yet.";
$publishtxt{'30'}="Publish status";
$publishtxt{'31'}="Draft";
$publishtxt{'32'}="Publish";
### DRAFT + PUBLISH MOD END ###

</add after>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'login',"LogInOut.pl&Login",
</search for>

<add before>
'changepublish',"ManageBoards.pl&ChangePublishMode",
</add before>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
	# figure out what to print
</search for>

<add before>
	my $draftreplychecked;
</add before>

<search for>
	if ($maintenance) { $mainchecked = ' checked'; }
</search for>

<add before>
	if ($draftreply) { $draftreplychecked = ' checked'; }
</add before>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'389'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="fadertext" size="10" value="$color{'fadertext'}"></td>
  </tr><tr>
</search for>

<add after>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$publishtxt{'05'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="draftreply"$draftreplychecked></td>
  </tr><tr>
</add after>

<search for>
	$maintenancetext = $FORM{'maintenancetext'} || "";
</search for>

<add before>
	$draftreply = $FORM{'draftreply'} eq 'on' ? 1 : 0;
</add before>

<search for>
\$MenuType = $MenuType;					# 1 for text menu or anything else for images menu
</search for>

<add before>
\$draftreply = $draftreply;					# 0 for direct replies without check in all boards
</add before>

<edit file>
Sources/ManageBoards.pl
</edit file>

<search for>
				$boardinfo[2] =~ s/[\n\r]//g;
</search for>

<add after>
### DRAFT + PUBLISH MOD START ###
				if (-e("$boardsdir/$curboard.pub")) { $publish=qq~<font size="1">$publishtxt{'02'}</font>~; } else { $publish=qq~<font size="1">$publishtxt{'01'}</font>~; }
### DRAFT + PUBLISH MOD END ###
</add after>

<search for>
        <input type="text" name="boardname" value="$curboardname" size="30"><br>
</search for>

<replace>
        <input type="text" name="boardname" value="$curboardname" size="30"> <a href="$scripturl?action=changepublish;board=$curboard">$publish</a><br>
</replace>

<search for>
sub ReorderBoards {
</search for>

<add before>
### DRAFT + PUBLISH MOD START ###
sub ChangePublishMode {
	&is_admin;

	my $curboard = $INFO{'board'};
	
	chomp $curboard;

	if (-e("$boardsdir/$curboard.pub")) {
		unlink "$boardsdir/$curboard.pub";
	} else {
		fopen(FILE,">$boardsdir/$curboard.pub");
	}

	$yySetLocation = qq~$scripturl?action=manageboards~;
	&redirectexit;
}
### DRAFT + PUBLISH MOD END ###

</add before>

<search for>
			unlink("$datadir/$id\.data");
</search for>

<add after>
			unlink("$datadir/$id\.show");
</add after>

<edit file>
Sources/ManageCats.pl
</edit file>

<search for>
					unlink("$datadir/$id.data");
</search for>

<add after>
					unlink("$datadir/$id.show");
</add after>

<edit file>
Sources/RemoveThread.pl
</edit file>

<search for>
	unlink("$datadir/$thread.data");
</search for>

<add after>
	unlink("$datadir/$thread.show");
</add after>

<edit file>
Sources/RemoveOldThreads.pl
</edit file>

<search for>
					unlink("$datadir/$num.data");
</search for>

<add after>
					unlink("$datadir/$num.show");
</add after>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
		# Set thread class depending on locked status and number of replies.
		$threadclass = 'thread';
</search for>

<add before>
### DRAFT + PUBLISH MOD START ###
		if (!-e("$datadir/$mnum.show")) {
			fopen(FILE,">$datadir/$mnum.show");
			for (my $i=0; $i <= $mreplies; $i++) {
				print FILE "1\n";
			}
			fclose(FILE);
		}
	
		fopen(FILE,"$datadir/$mnum.show");
		@viewthis=<FILE>;
		fclose(FILE);

		if ($viewthis[0] == 0 && !($username eq $musername || exists $moderators{$username} || $settings[7] eq 'Administrator')) { next; }
		elsif ($viewthis[0] == 0 && ($username eq $musername || exists $moderators{$username} || $settings[7] eq 'Administrator')) { $showthis="$publishtxt{'10'}: "; }
		elsif ($viewthis[0] == 1) { $showthis=""; }
### DRAFT + PUBLISH MOD END ###
</add before>

<search for>
        <td class="windowbg" valign="middle" width="44%" bgcolor="$color{'windowbg'}"><font size="2">$new <a href="$cgi;action=display;num=$mnum"><b>$msub</b></a> $pages</font></td>
</search for>

<replace>
        <td class="windowbg" valign="middle" width="44%" bgcolor="$color{'windowbg'}"><font size="2"><b>$showthis</b>$new <a href="$cgi;action=display;num=$mnum"><b>$msub</b></a> $pages</font></td>
</replace>

<edit file>
Sources/Display.pl
</edit file>

<search for>
	my(@userprofile,@messages,@bgcolors);
</search for>

<add after>
	my @viewthis;
</add after>

<search for>
	# Get the class of this thread, based on lock status and number of replies.
</search for>

<add before>
### DRAFT + PUBLISH MOD START ###
	if (!-e("$datadir/$viewnum.show")) {
		fopen(FILE,">$datadir/$viewnum.show");
		for (my $i=0; $i <= $mreplies; $i++) {
			print FILE "1\n";
		}
		fclose(FILE);
	}
	
	fopen(FILE,"$datadir/$viewnum.show");
	@viewthis=<FILE>;
	fclose(FILE);

	if ($viewthis[0] == 0 && !($username eq $musername || exists $moderators{$username} || $settings[7] eq 'Administrator')) { &fatal_error($publishtxt{'20'}); }
	elsif ($viewthis[0] == 0 && ($username eq $musername || exists $moderators{$username} || $settings[7] eq 'Administrator')) { $showthis="$publishtxt{'10'}: "; }
	elsif ($viewthis[0] == 1) { $showthis=""; }
### DRAFT + PUBLISH MOD END ###

</add before>

<search for>
        <font size=2 class="text1" color="$color{'titletext'}"><b>&nbsp;$txt{'118'}: $msubthread</b> &nbsp;($txt{'641'} $views $txt{'642'})</font></td>
</search for>

<replace>
        <font size=2 class="text1" color="$color{'titletext'}"><b>&nbsp;$txt{'118'}: $showthis$msubthread</b> &nbsp;($txt{'641'} $views $txt{'642'})</font></td>
</replace>

<search for>
		# Should we show "last modified by?"
</search for>

<add before>
### DRAFT + PUBLISH MOD START ###
		if ($viewthis[$counter] == 0 && !($username eq $musername || exists $moderators{$username} || $settings[7] eq 'Administrator')) { next; }
		elsif ($viewthis[$counter] == 0 && ($username eq $musername || exists $moderators{$username} || $settings[7] eq 'Administrator')) { $showthis="$publishtxt{'10'}: "; }
		elsif ($viewthis[$counter] == 1) { $showthis=""; }
### DRAFT + PUBLISH MOD END ###

</add before>

<search for>
                <font size="2"><B>$msub</b></font><BR>
</search for>

<replace>
                <font size="2"><B>$showthis$msub</b></font><BR>
</replace>

<edit file>
Sources/Post.pl
</edit file>

<search for>
	if( $threadid ne '' ) {
</search for>

<add after>
### DRAFT + PUBLISH MOD START ###
		if (!-e("$datadir/$threadid.show")) {
			fopen(FILE,">$datadir/$threadid.show");
			for (my $i=0; $i <= $mreplies; $i++) {
				print FILE "1\n";
			}
			fclose(FILE);
		}
		
		fopen(FILE,"$datadir/$threadid.show");
		@viewthis=<FILE>;
		fclose(FILE);
	
		if ($viewthis[0] == 0 && !(exists $moderators{$username} || $settings[7] eq 'Administrator')) { &fatal_error($publishtxt{'20'}); }
### DRAFT + PUBLISH MOD END ###
</add after>

<search for>
	$submittxt = "$txt{'105'}";
</search for>

<add before>
	$publishas=qq~
<tr>
<td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$publishtxt{'30'}:</b></font><BR><BR></td>
<td class="windowbg" bgcolor="$color{'windowbg'}"><select name="publishmode">
~;
	if (-e("$boardsdir/$currentboard.pub") && !(exists $moderators{$username} || $settings[7] eq 'Administrator') && ($threadid eq '' || $draftreply == 1)) {
		$publishas .=qq~<option value="0" selected>$publishtxt{'31'}</option>~;
	} else {
		$publishas .=qq~<option value="0">$publishtxt{'31'}</option>
<option value="1" selected>$publishtxt{'32'}</option>~;
	}
	$publishas .=qq~
</select><BR><BR>
</td></tr>
~;
</add before>

<search for>
$notification
$lastmod
</search for>

<add before>
$publishas
</add before>

<search for>
	if( $FORM{'previewmodify'} ) {
</search for>

<add after>
		$publishas=qq~
<tr>
<td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$publishtxt{'30'}:</b></font><BR><BR></td>
<td class="windowbg" bgcolor="$color{'windowbg'}"><input type="hidden" name="oldpub" value="$FORM{'oldpub'}><select name="publishmode">
~;
		if (-e("$boardsdir/$currentboard.pub") && !(exists $moderators{$username} || $settings[7] eq 'Administrator') && $oldpub == 0 && ($postid == 0 || $draftreply == 1)) {
			$publishas .=qq~<option value="0" selected>$publishtxt{'31'}</option>~;
		} else {
			if ($FORM{'publishmode'} == 1) {
				$publishas .=qq~<option value="0">$publishtxt{'31'}</option>
<option value="1" selected>$publishtxt{'32'}</option>~;
			} else {
				$publishas .=qq~<option value="0" selected>$publishtxt{'31'}</option>
<option value="1">$publishtxt{'32'}</option>~;	
			}		
		}
		$publishas .=qq~
</select><BR><BR>
</td></tr>
~;


</add after>

<search for>
		$destination = 'post2';
</search for>

<add before>
		$publishas=qq~
<tr>
<td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$publishtxt{'30'}:</b></font><BR><BR></td>
<td class="windowbg" bgcolor="$color{'windowbg'}"><select name="publishmode">
~;
		if (-e("$boardsdir/$currentboard.pub") && !(exists $moderators{$username} || $settings[7] eq 'Administrator') && ($threadid eq '' || $draftreply == 1)) {
			$publishas .=qq~<option value="0" selected>$publishtxt{'31'}</option>~;
		} else {
			$publishas .=qq~<option value="0">$publishtxt{'31'}</option>
<option value="1" selected>$publishtxt{'32'}</option>~;
		}
		$publishas .=qq~
</select><BR><BR>
</td></tr>
~;
</add before>

<search for>
	# Get the form values
</search for>

<add after>
	$publishit=$FORM{'publishmode'};

</add after>

<search for>
		# This is a new thread. Save it.
</search for>

<add after>
		fopen(FILE,">$datadir/$newthreadid.show");
		print FILE "$publishit\n";
		fclose(FILE);
</add after>

<search for>
		++$mreplies;
</search for>

<add after>
		if (-e("$datadir/$threadid.show")) {
			fopen(FILE,">>$datadir/$threadid.show");
			print FILE "$publishit\n";
			fclose(FILE);
		} else {
			fopen(FILE,">$datadir/$threadid.show");
			for (my $i=0; $i <= $mreplies; $i++) {
				print FILE "1\n";
			}
			print FILE "$publishit\n";
			fclose(FILE);
		}
</add after>

<search for>
		foreach $line (@messages) { #start for each
</search for>

<add before>
### DRAFT + PUBLISH MOD START ###
	if (!-e("$datadir/$threadid.show")) {
		fopen(FILE,">$datadir/$threadid.show");
		for (my $i=0; $i <= $mreplies; $i++) {
			print FILE "1\n";
		}
		fclose(FILE);
	}
	
	fopen(FILE,"$datadir/$threadid.show");
	@viewthis=<FILE>;
	fclose(FILE);
### DRAFT + PUBLISH MOD END ###
</add before>

<search for>
			($trash, $tempname, $trash, $tempdate, $trash, $trash, $trash, $trash, $message, $ns) = split(/\|/,$line);

</search for>

<replace>
			($trash, $tempname, $trash, $tempdate, $tempusername, $trash, $trash, $trash, $message, $ns) = split(/\|/,$line);

### DRAFT + PUBLISH MOD START ###
			if ($viewthis[$counter] == 0 && !($username eq $tempusername || exists $moderators{$username} || $settings[7] eq 'Administrator')) { next; }
### DRAFT + PUBLISH MOD END ###
</replace>

<search for>
			&wrap2;
</search for>

<add after>
			$counter++;
</add after>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
	($sub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip,  $message, $mns, $mlm, $mlmb) = split(/\|/,$messages[$postid]);
</search for>

<add after>
### DRAFT + PUBLISH MOD START ###
	if (!-e("$datadir/$threadid.show")) {
		fopen(FILE,">$datadir/$threadid.show");
		for (my $i=0; $i <= $mreplies; $i++) {
			print FILE "1\n";
		}
		fclose(FILE);
	}
	
	fopen(FILE,"$datadir/$threadid.show");
	@viewthis=<FILE>;
	fclose(FILE);

	if ($viewthis[0] == 0 && $postid == 0 && !($username eq $musername || exists $moderators{$username} || $settings[7] eq 'Administrator')) { &fatal_error($publishtxt{'20'}); }
	elsif ($viewthis[0] == 0 && $postid != 0 && !(exists $moderators{$username} || $settings[7] eq 'Administrator')) { &fatal_error($publishtxt{'20'}); }
	elsif ($viewthis[$postid] == 0 && !($username eq $musername || exists $moderators{$username} || $settings[7] eq 'Administrator')) { &fatal_error($publishtxt{'20'}); }
### DRAFT + PUBLISH MOD END ###
</add after>

<search for>
	$submittxt = "$txt{'10'}";
</search for>

<add before>
	$publishas=qq~
<tr>
<td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$publishtxt{'30'}:</b></font><BR><BR></td>
<td class="windowbg" bgcolor="$color{'windowbg'}"><input type="hidden" name="oldpub" value="$viewthis[$postid]"><select name="publishmode">
~;
	if (-e("$boardsdir/$currentboard.pub") && !(exists $moderators{$username} || $settings[7] eq 'Administrator') && $viewthis[$postid] == 0) {
		$publishas .=qq~<option value="0" selected>$publishtxt{'31'}</option>~;
	} else {
		if ($viewthis[$postid] == 1) {
			$publishas .=qq~<option value="0">$publishtxt{'31'}</option>
<option value="1" selected>$publishtxt{'32'}</option>~;
		} else {
			$publishas .=qq~<option value="0" selected>$publishtxt{'31'}</option>
<option value="1">$publishtxt{'32'}</option>~;	
		}		
	}
	$publishas .=qq~
</select><BR><BR>
</td></tr>
~;
</add before>

<search for>
			unlink("$datadir/$tnum.data");
</search for>

<add after>
			unlink("$datadir/$tnum.show");
</add after>

<search for>
			# Save thread without the deleted post.
</search for>

<add after>
			if (!-e("$datadir/$threadid.show")) {
				fopen(FILE,">$datadir/$threadid.show");
				foreach (@messages) {
					print FILE "1\n";
				}
				fclose(FILE);
			}

			fopen(FILE,"$datadir/$threadid.show");
			@viewthis=<FILE>;
			fclose(FILE);

			$viewthis[$postid] = '';

			fopen(FILE,">$datadir/$threadid.show");
			foreach (@viewthis) {
				chomp;

				if ($_ ne '') {
					print FILE "$_\n";
				}
			}
			fclose(FILE);

</add after>

<search for>
		$name = $FORM{'name'};
</search for>

<add before>
		$publishit=$FORM{'publishmode'};
</add before>

<search for>
		$messages[$postid] = qq~$subject|$mname|$memail|$mdate|$musername|$icon|0|$useredit_ip|$message|$ns|$date|$username\n~;
</search for>

<add after>
		if (!-e("$datadir/$threadid.show")) {
			fopen(FILE,">$datadir/$threadid.show");
			foreach (@messages) {
				print FILE "1\n";
			}
			fclose(FILE);
		}

		fopen(FILE,"$datadir/$threadid.show");
		@viewthis=<FILE>;
		fclose(FILE);

		$viewthis[$postid] = $publishit;

		fopen(FILE,">$datadir/$threadid.show");
		foreach (@viewthis) {
			chomp;

			if ($_ ne '') {
				print FILE "$_\n";
			}
		}
		fclose(FILE);

</add after>
